package org.kaveh.commons.farsi.letter;

import org.kaveh.commons.farsi.providers.ArabicLetterProvider;
import org.kaveh.commons.farsi.providers.FarsiLetterProvider;

/**
 * Arabic Letter is a place holder for static methods which will provide
 * services at letter level.
 * 
 * @author Kaveh Ranjbar
 * 
 */
public class ArabicLetter {

	public static boolean isArabicDigit(char inputLetter) {
		return (ArabicLetterProvider.getDigits().contains(String
				.valueOf(inputLetter))) ? true : false;
	}

	public static boolean isArabicLetter(char inputLetter) {
		return (ArabicLetterProvider.getConsonants().contains(
				String.valueOf(inputLetter)) && !FarsiLetterProvider
				.getConsonants().contains(String.valueOf(inputLetter))) ? true
				: false;
	}

}
