package org.kaveh.commons.farsi.letter;

import org.kaveh.commons.farsi.constatns.ArabicLetterConstants;
import org.kaveh.commons.farsi.constatns.FarsiLetterConstants;
import org.kaveh.commons.farsi.constatns.LatinLetterConstants;
import org.kaveh.commons.farsi.providers.FarsiLetterProvider;
import org.kaveh.commons.farsi.utils.ConstantReflectionUtilies;

/**
 * Farsi Letter is a place holder for static methods which will provide services
 * at letter level.
 * 
 * @author Kaveh Ranjbar
 * 
 */
public class FarsiLetter {

	public static boolean isFarsiDigit(char inputLetter) {
		return (FarsiLetterProvider.getDigits().contains(String
				.valueOf(inputLetter))) ? true : false;
	}

	public static boolean isFarsiLetter(char inputLetter) {
		return (FarsiLetterProvider.getConsonants().contains(
				String.valueOf(inputLetter)) && !FarsiLetterProvider
				.getConsonants().contains(String.valueOf(inputLetter))) ? true
				: false;
	}

	public static char replaceArabicDigitWithFarsi(char inputDigit) {
		char result = inputDigit;
		if (ArabicLetter.isArabicDigit(inputDigit)) {
			result = ConstantReflectionUtilies.findMatchByTranslation(
					inputDigit, ArabicLetterConstants.Digits.class,
					FarsiLetterConstants.Digits.class);
		}
		return result;
	}

	public static char replaceArabicLetterWithFarsi(char inputLetter) {
		char result = inputLetter;
		if (ArabicLetter.isArabicLetter(inputLetter)) {
			result = ConstantReflectionUtilies.findMatchByTranslation(
					inputLetter, ArabicLetterConstants.Consonants.class,
					FarsiLetterConstants.Consonants.class);
		}
		return result;
	}

	public static char replaceLatinDigitWithFarsi(char inputDigit) {
		char result = inputDigit;
		if (LatinLetter.isLatinDigit(inputDigit)) {
			result = ConstantReflectionUtilies.findMatchByTranslation(
					inputDigit, LatinLetterConstants.Digits.class,
					FarsiLetterConstants.Digits.class);
		}
		return result;
	}

}
