package org.kaveh.commons.farsi.providers;

import java.util.ArrayList;
import java.util.List;

import org.kaveh.commons.farsi.constatns.FarsiLetterConstants;
import org.kaveh.commons.farsi.utils.ConstantReflectionUtilies;

/**
 * 
 * Class to retrieve farsi constant symbols
 * 
 * @author Kaveh Ranjbar
 * 
 */
public class FarsiLetterProvider {

	public static List<String> getShortVowelvs() {
		return ConstantReflectionUtilies
				.getSymbolList(FarsiLetterConstants.Vowels.ShortVowels.class);
	}

	public static List<String> getLongVowelvs() {
		return ConstantReflectionUtilies
				.getSymbolList(FarsiLetterConstants.Vowels.LongVowels.class);
	}

	public static List<String> getVowelvs() {
		List<String> result = new ArrayList<String>();
		result.addAll(ConstantReflectionUtilies
				.getSymbolList(FarsiLetterConstants.Vowels.ShortVowels.class));
		result.addAll(ConstantReflectionUtilies
				.getSymbolList(FarsiLetterConstants.Vowels.LongVowels.class));
		return result;
	}

	public static List<String> getConsonants() {
		return ConstantReflectionUtilies
				.getSymbolList(FarsiLetterConstants.Consonants.class);
	}

	public static List<String> getDigits() {
		return ConstantReflectionUtilies
				.getSymbolList(FarsiLetterConstants.Digits.class);
	}

}
