package org.kaveh.commons.farsi.utils;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

@SuppressWarnings("rawtypes")
public class ConstantReflectionUtilies {

	/**
	 * 
	 * This local method, reads field values from constant classes, uses
	 * reflection to do its job. It uses a map, since reflection returns
	 * overridden fields twice (once from child, then from mother) We check, if
	 * the key exists in the map, we will not override since reflection first
	 * returns child class fields.
	 * 
	 * @param letterClass
	 * @return
	 */
	public static List<String> getSymbolList(Class letterClass) {

		List<String> result = new ArrayList<String>();

		LinkedHashMap<String, String> myMap = new LinkedHashMap<String, String>();

		for (int i = 0; i < letterClass.getFields().length; i++) {

			// result.add((String) inputClass.getFields()[i].get(null));
			if (!myMap.containsKey(letterClass.getFields()[i].getName())) {
				try {
					myMap.put(letterClass.getFields()[i].getName(),
							(String) letterClass.getFields()[i].get(null));
				} catch (SecurityException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		}
		result.addAll(myMap.values());
		return result;
	}

	//TODO: REFACTOR!!! CODE DUPLICATE...
	public static List<String> getKeyList(Class letterClass) {

		List<String> result = new ArrayList<String>();

		LinkedHashMap<String, String> myMap = new LinkedHashMap<String, String>();

		for (int i = 0; i < letterClass.getFields().length; i++) {

			// result.add((String) inputClass.getFields()[i].get(null));
			if (!myMap.containsKey(letterClass.getFields()[i].getName())) {
				try {
					myMap.put(letterClass.getFields()[i].getName(),
							(String) letterClass.getFields()[i].get(null));
				} catch (SecurityException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalArgumentException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

		}
		result.addAll(myMap.keySet());
		return result;
	}
	public static String findLetterKeyByValue(char inputLetter, Class letterClass) {
		String result =  null;
		for (int i = 0; i < letterClass.getFields().length; i++) {
			try {

				if (letterClass.getFields()[i].get(null).toString().charAt(0) == inputLetter) {
					result = letterClass.getFields()[i].getName();
					break;
				}
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (SecurityException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}
		return result;
	}
	
	public static char findValueByLetterKey(String inputFieldName, Class letterClass) {
		char result = ' ';
		for (int i = 0; i < letterClass.getFields().length; i++) {
			try {
				if (letterClass.getFields()[i].getName().equals(
						inputFieldName)) {
					result = letterClass.getFields()[i].get(null).toString().charAt(0);
					break;
				}
			} catch (IllegalArgumentException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (SecurityException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}
		return result;
	}
	
	public static String findKeyByOrder(int numberInList, Class letterClass) {
		String result =  null;
		if (numberInList <= letterClass.getFields().length) {
		result = letterClass.getFields()[numberInList].getName(); 
		}

		return result;
	}

	public static String findValueByOrder(int numberInList, Class letterClass) {
		String result =  null;
		if (numberInList <= letterClass.getFields().length ) {
		try {
			result = letterClass.getFields()[numberInList].get(null).toString();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} 
		}

		return result;
	}
	
	public static char findMatchByTranslation(char inputLetter, Class sourceLetterClass, Class destinationLetterClass)
	{
		char result = inputLetter;
		String key = findLetterKeyByValue(inputLetter, sourceLetterClass);
		result = ConstantReflectionUtilies.findValueByLetterKey(key, destinationLetterClass);
		return result;
	}
	
	private static LinkedHashMap<Character, Character> getDiffOfLetters(Class sourceLetterClass, Class destinationLetterClass){
		LinkedHashMap<Character, Character> result = new LinkedHashMap<Character, Character>();
		for (String key : getKeyList(sourceLetterClass)){
			char source = findValueByLetterKey(key, sourceLetterClass);
			char destination = findValueByLetterKey(key, destinationLetterClass);
			if ( source != destination ) {
				result.put(source, destination);
			}
		}
		return result;
	}
	
	public static String getFixedString(String input,Class sourceLetterClass, Class destinationLetterClass){
		//String result = "";
		LinkedHashMap<Character, Character> data =  getDiffOfLetters(sourceLetterClass, destinationLetterClass);
		for (char source : data.keySet()) {
			input = input.replaceAll(String.valueOf(source), String.valueOf(data.get(source)));
		}		
		return input;
	}
}
