package org.kaveh.commons.farsi.word;

import org.kaveh.commons.farsi.letter.FarsiLetter;
import org.kaveh.commons.farsi.providers.FarsiLetterProvider;

/**
 * FarsiWord is a place holder for methods which will manipulate a single
 * word.
 * 
 * @author Kaveh Ranjbar
 * 
 */
public class FarsiWord {

	/**
	 * 
	 * @param wordWithShortVowel
	 *            Any word with a short Vowel
	 * @return same word without any short vowels
	 */
	public static String removeShortVowel(String stringWithShortVowel) {
		for (String shortVowel : FarsiLetterProvider.getShortVowelvs()) {
			stringWithShortVowel = stringWithShortVowel.replaceAll(shortVowel, "");
		}
		return stringWithShortVowel;
	}

	/**
	 * 
	 * @param wordWithShortVowel
	 *            Any word with a short Vowel
	 * @return is there any short vowels?
	 */
	public static boolean hasShortVowel(String stringWithShortVowel) {

		return (removeShortVowel(stringWithShortVowel).length() == stringWithShortVowel.length()) ? false : true;
	}
	
	public static String replaceArabicDigit(String stringWithArabicDigits) {
		String result = "";
		for (int i = 0; i < stringWithArabicDigits.length(); i++) {
			result = result + FarsiLetter.replaceArabicDigitWithFarsi(stringWithArabicDigits.charAt(i));
		}
		return result;
	}
	
	public static boolean hasArabicDigit(String stringWithArabicDigits) {
		return (replaceArabicDigit(stringWithArabicDigits).equals(stringWithArabicDigits)) ? false:true;
	}
	
	public static String replaceArabicLetters(String stringWithArabicLetters) {
		String result = "";
		for (int i = 0; i < stringWithArabicLetters.length(); i++) {
			result = result + FarsiLetter.replaceArabicLetterWithFarsi(stringWithArabicLetters.charAt(i));
		}
		return result;
	}
	
	public static boolean hasArabicLetter(String stringWithArabicLetters) {
		return (replaceArabicLetters(stringWithArabicLetters).equals(stringWithArabicLetters)) ? false:true;
	}
		
	public static String replaceLatinDigit(String stringWithLatinDigits) {
		String result = "";
		for (int i = 0; i < stringWithLatinDigits.length(); i++) {
			result = result + FarsiLetter.replaceLatinDigitWithFarsi(stringWithLatinDigits.charAt(i));
		}
		return result;
	}
	
	public static boolean hasLatinDigit(String stringWithLatinDigits) {
		return (replaceLatinDigit(stringWithLatinDigits).equals(stringWithLatinDigits)) ? false:true;
	}
	
}
